/* Copyright (C) 2009 Stefan Frenz
 * 
 * This file is part of SJC, the Small Java Compiler written by Stefan Frenz.
 * 
 * SJC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * SJC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with SJC. If not, see <http://www.gnu.org/licenses/>.
 */

package backend.srb;

/**
 * SRBConstraint: constraint for SRB register handling
 * 
 * @author S. Frenz
 * @version 090214 initial version
 */

public class SRBConstraint {
  public final static int C_ALL       = 0; //get all constraints
  public final static int C_NONE      = 0; //this constraint is not in use
  public final static int C_EQUALS    = 1; //native reg1 needs to be identical to native reg2
  public final static int C_AVOIDS    = 2; //native reg1 must not be identical to native reg2
  public final static int C_CONSTINT  = 3; //reg1 is constant int value and matches constInt
  public final static int C_CONSTLONG = 4; //reg1 is constant long value and matches constLong
  public final static int C_REQUIRED  = 5; //reg1 is required somewhere
  
  public SRBConstraint nextConstraint;
  public int type;
  public SRBRegister reg1, reg2;
  public int constInt;
  public long constLong;
}
